use std::collections::HashSet;

use crate::{solve1, solve2};
static INPUT: &str = include_str!("../../data/year2022/day03.txt");
static SAMPLE_INPUT: &str = include_str!("../../data/year2022/day03_test.txt");

const fn prio(c: char) -> i64 {
    match c {
        'a'..='z' => c as i64 - 96,
        'A'..='Z' => c as i64 - 64 + 26,
        _ => unreachable!(),
    }
}

fn solve1(input: &str) -> i64 {
    input
        .lines()
        .map(|line| {
            let (left, right) = line.split_at(line.len() / 2);
            let set: Vec<char> = left.chars().collect();
            let dup = right
                .chars()
                .find(|c| set.contains(c))
                .expect("char has no duplicate");
            prio(dup)
        })
        .sum()
}

fn solve2(input: &str) -> i64 {
    let mut lines = input.lines();
    let mut sum = 0;
    while let Some(first) = lines.next() {
        let second = lines.next().expect("No second rucksack");
        let third = lines.next().expect("No third rucksack");
        let set1: Vec<char> = first.chars().collect();
        let set2: Vec<char> = second.chars().collect();
        let dup = third
            .chars()
            .find(|c| set1.contains(c) && set2.contains(c))
            .expect("No dupes");
        sum += prio(dup)
    }
    sum
}

solve1!(157, 8298);
solve2!(70, 2708);